unit wcpanel;
// TWHCompress UI panel v1.5
// Note: This unit is built assuming an application type of "thtWebapp"
// If your application is of another type, do a global replace of "htWebApp"
// with the correct type, e.g. "Webapp", "htdbWebapp" etc.


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  UTPANFRM, ExtCtrls, StdCtrls, TpMenu, UpdateOk, tpAction, IniLink,
  WebIniFL, Toolbar, Restorer, Buttons, eButton, CompLHA, WebTypes,
  WebLink, WebCompr, ComCtrls, tpStatus, TpApplic, htWebApp, Webapp,
  whcompr;

type
  TfmAppWebCompress = class(TutParentForm)
    dm: TtpDataModule;
    Panel1: TPanel;
    tpVerbButton2: TtpVerbButton;
    tpVerbButton1: TtpVerbButton;
    Status: TButton;
    SitesList: TComboBox;
    Panel2: TPanel;
    GatherFileList: TListBox;
    Panel3: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    UploadPath: TEdit;
    OriginPath: TEdit;
    AppID: TEdit;
    msg: TMemo;
    WebCompress1: TWHCompress;
    CompLHA1: TCompLHA;
    tpApplication1: TtpApplication;
    NoBr: TWebAction;
    Label4: TLabel;
    Password: TEdit;
    UseSignals: TCheckBox;
    procedure SetList(UIList,WCList: TStrings);
    procedure WebCompressAfterDeploy(processed: Integer; files: TStrings);
    procedure StatusClick(Sender: TObject);
    procedure WebCompressExpand(var filename: String; status: TStrings);
    procedure WebCompressDeploy(files: TStrings);
    procedure WebCompressAfterExpand(const filename: String;
      filesprocessed, status: TStrings);
    procedure WebCompress1AfterGather(files: TStrings);
    procedure WebCompress1Gather(files: TStrings);
    procedure SitesListDblClick(Sender: TObject);
    procedure WebCompress1AfterChangeProperty(const propertyname: String);
    procedure UploadPathExit(Sender: TObject);
    procedure OriginPathExit(Sender: TObject);
    procedure AppIDExit(Sender: TObject);
    procedure SitesListChange(Sender: TObject);
    procedure WebCompress1Update(Sender: TObject);
    procedure GatherFileListMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure NoBrExecute(Sender: TObject);
    procedure PasswordExit(Sender: TObject);
    procedure tpApplication1Idle(Sender: TObject; var Done: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    Webapp: thtWebApp;
    function Init: Boolean; override;
    procedure Save(Restorer:TFormRestorer); override;
    procedure Load(Restorer:TFormRestorer); override;
    end;

var
  fmAppWebCompress: TfmAppWebCompress;

implementation

{$R *.DFM}

uses
  WebInfou, utSpltfm, AppMain, ucstring
{$IFDEF HASSERVICES} { Feature available to those who license our Services Panel }
  ,srvpanel
{$ENDIF}
{$IFDEF ISTP} { Feature used in our TurboPress app }
  ,tpOnart
{$ENDIF}
  ;

//------------------------------------------------------------------------------

function TfmAppWebCompress.Init:Boolean;
begin
  Result:= inherited Init;
  if not result then
    exit;
  Webapp := Thtwebapp(pWebapp);
  WebCompress1.Webapp := webapp;
  WebCompress1.WebCommandLine := fmWebAppMainForm.WebCommandLine;
  if not WebCompress1.tpUpdated then
      WebCompress1.refresh; // as previous call didn't have valid WebCommandLine
  result := WebCompress1.tpUpdated;
end;

//------------------------------------------------------------------------------

procedure TfmAppWebCompress.Save(Restorer:TFormRestorer);
//example OnSave Handler
begin
  inherited Save(Restorer);
  with Restorer.IniFileLink do begin
    //    BooleanEntry['xyz']:=   button.Down;
    end;
end;

procedure TfmAppWebCompress.Load(Restorer:TFormRestorer);
//example OnLoad Handler
begin
  inherited Load(Restorer);
  with Restorer.IniFileLink do begin
    //    Button.Down:= BooleanEntry['xyz'];
    end;
end;

//------------------------------------------------------------------------------

procedure TfmAppWebCompress.WebCompressAfterDeploy(processed: Integer; files: TStrings);
begin
(*
   msg.lines.add('==='#13#10'After deploy of: '+inttostr(processed));
   msg.lines.addstrings(files);
*)
{$IFDEF HASSERVICES} { Feature available to those who license our Services Panel }
  with fmappSPISServices do
     CheckForDateStamps(SitesRoot.Text);
{$ENDIF}

{$IFDEF ISTP} { Feature used in our TurboPress app }
  ArtDM.OpenDatabases;
{$ENDIF}

  if WebCompress1.AppID = WebApp.AppID then
     Webapp.refresh; { register changes... }
  StatusClick(nil); { only at this late stage do we have a status to show }
end;


procedure TfmAppWebCompress.StatusClick(Sender: TObject);
begin
   msg.lines.clear;
   msg.lines.addstrings(WebCompress1.Status);
end;

procedure TfmAppWebCompress.WebCompressExpand(var filename: String;
  status: TStrings);
begin
(*
   msg.lines.add('==='#13#10'Before Expand of: '+filename);
   msg.lines.addstrings(status);
*)
end;

procedure TfmAppWebCompress.WebCompressDeploy(files: TStrings);
begin
{$IFDEF ISTP} { Feature used in our TurboPress app }
  ArtDM.CloseDatabases;
{$ENDIF}
(*
   msg.lines.add('==='#13#10'Before deploy of: ');
   msg.lines.addstrings(files);
*)
end;
        
procedure TfmAppWebCompress.WebCompressAfterExpand(const filename: String;
  filesprocessed, status: TStrings);
begin
(*
   msg.lines.add('==='#13#10'After Expand of: '+filename);
   msg.lines.addstrings(files);
*)
{$IFDEF ISTP} { Feature used in our TurboPress app }
  ArtDM.CheckReindex(filesProcessed);
{$ENDIF}

end;


procedure TfmAppWebCompress.WebCompress1AfterGather(files: TStrings);
begin
(*
  msg.lines.add('==='#13#10'Gather completed.');
*)
  StatusClick(nil); { only at this late stage do we have a status to show }
end;

procedure TfmAppWebCompress.WebCompress1Gather(files: TStrings);
begin
(*
   msg.lines.add('==='#13#10'Gathering files matching these specifications into: '+WebCompress1.GatherArchive);
   msg.lines.addstrings(files);
*)
end;


procedure TfmAppWebCompress.SitesListDblClick(Sender: TObject);
begin
  WebCompress1.ExecuteVerbByName('Edit Sites');
end;

procedure TfmAppWebCompress.SetList(UIList,WCList: TStrings);
var listcount: Integer;
begin
  with UIList do
  begin
    Clear;
    for listcount := 0 to pred(WCList.count) do
       Add(RightofEqual(WCList[listcount]));
  end;
end;

procedure TfmAppWebCompress.WebCompress1AfterChangeProperty(
  const propertyname: String);
begin
  if propertyname='Sites' then
  begin
    SetList(SitesList.Items,WebCompress1.Sites);
    exit;
  end else if propertyname = 'GatherList' then
  begin
    SetList(GatherFileList.Items,WebCompress1.GatherList);
    exit;
  end;

  { for the rest, we could do one by one, but let's be lazy... }
  SitesList.Text := WebCompress1.Site;
  UploadPath.Text :=WebCompress1.UploadPath;
  AppID.Text := WebCompress1.AppID;
  Password.Text:= WebCompress1.Password;
  OriginPath.Text := WebCompress1.OriginPath;
end;

procedure TfmAppWebCompress.UploadPathExit(Sender: TObject);
begin
  WebCompress1.UploadPath := UploadPath.Text;
end;

procedure TfmAppWebCompress.OriginPathExit(Sender: TObject);
begin
  WebCompress1.OriginPath := OriginPath.Text;
end;

procedure TfmAppWebCompress.AppIDExit(Sender: TObject);
begin
  WebCompress1.AppID := AppID.Text;
end;

procedure TfmAppWebCompress.SitesListChange(Sender: TObject);
begin
  WebCompress1.Site := SitesList.text;
end;

procedure TfmAppWebCompress.WebCompress1Update(Sender: TObject);
begin
  SetList(SitesList.Items,WebCompress1.Sites);
  SitesList.Text := WebCompress1.Site;
end;

procedure TfmAppWebCompress.GatherFileListMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   if SSRight in Shift then
      WebCompress1.ExecuteVerbByName('Edit GatherList');
end;
procedure TfmAppWebCompress.NoBrExecute(Sender: TObject);
begin
  inherited;
  WebCompress1.SendListPropertyNoBr(NoBR.Command);
end;


procedure TfmAppWebCompress.PasswordExit(Sender: TObject);
begin
  inherited;
  WebCompress1.Password := Password.Text;
end;

procedure TfmAppWebCompress.tpApplication1Idle(Sender: TObject;
  var Done: Boolean);
begin
  inherited;

  if UseSignals.checked then
    WebCompress1.ApplicationIdle(Sender,Done);
    
  Done := True; { slowish response, but easy on CPU }

{$IFDEF HASSERVICES} { if you've licensed our Services panel }
  fmAppSPISServices.DoMailCheck; { check/send for TMailMan Queue }
{$ENDIF}

end;

end.
